/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.client.internal.ProgressMonitoredServiceResponseHandler"); //$NON-NLS-1$

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$

(function() {

dojo.declare("com.ibm.team.apt.web.client.internal.ProgressMonitoredServiceResponseHandler", //$NON-NLS-1$
			 com.ibm.team.repository.web.transport.ServiceResponseHandler, {

	_label: null,
	_controller: null,
	_messageId: null,

	// ---- api ------------------------------------------------------------------------------------------------------------	

	setLabel: function(label, controller) {
		this._label= label;
		this._controller= controller;
	},
	
	// ---- implementation -------------------------------------------------------------------------------------------------	

	doStart: function() {
		this._setProgressMessage();
	},

	doCallback: function(returnVal) {
		try {
			this.inherited(arguments);
		} finally {
			this._removeProgressMessage();
		}
	},
	
	doErrorCallback: function(errorObj) {
		try {
			this.inherited(arguments);
		} finally {
			this._removeProgressMessage();
		}
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	_setProgressMessage: function() {
		if (dojo.isString(this._label)) {
			this._messageId= this._controller.setProgressMessage(this._label);
		}
	},
	
	_removeProgressMessage: function() {
		if (dojo.isString(this._label)) {
			this._controller.removeProgressMessage(this._messageId);
		}
	},
	
	__sentinel: null // terminates this class definition
});

})();
