/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.client.internal.SimpleCache");

(function() {
	
var TTL_INFINITE= -1;

dojo.declare("com.ibm.team.workitem.web.client.internal.SimpleCache", null, {
	
	constructor: function() {
		this._cache= new Object();
	},
	
	get: function(cacheKey) {
		var entry= this._cache[cacheKey];
		if (entry != null) {
			var now= (new Date()).getTime();
			if (entry.ttl == TTL_INFINITE || (entry.timestamp + entry.ttl > now))
				return entry;
		}
		return null;
	},
	
	put: function(cacheKey, result, ttl) {
		var entry= { 
			result: result,
			timestamp: (new Date()).getTime(),
			ttl: ttl
		};
		this._cache[cacheKey]= entry;
		return entry;
	},
	
	clear: function(cacheKey) {
		this._cache[cacheKey]= null;
	}
	
});

com.ibm.team.workitem.web.client.internal.SimpleCache.TTL_INFINITE= TTL_INFINITE;
com.ibm.team.workitem.web.client.internal.SimpleCache.TTL_MINUTE= 60000;

})();