/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2008. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.reports.web.ui.internal.ReportTemplatesNavigator");

dojo.require("dojo.i18n");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.team.reports.web.client.internal.ReportsClient");
dojo.require("com.ibm.team.reports.web.ui.internal.FolderWidget");
dojo.require("com.ibm.team.reports.web.ui.internal.ImagePool");

dojo.requireLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");

(function() { // module container

var ImagePool = com.ibm.team.reports.web.ui.internal.ImagePool;

var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
var ReportsClient = com.ibm.team.reports.web.client.internal.ReportsClient;

var DROPDOWN_HOVER = ImagePool.DD_ARROW_HOV;
var DROPDOWN       = ImagePool.DD_ARROW;

dojo.declare(
	"com.ibm.team.reports.web.ui.internal.ReportTemplatesNavigator", 
	[dijit._Widget, dijit._Templated], 
	{
		// summary: displays the report templates
		
		templatePath: dojo.moduleUrl("com.ibm.team.reports.web", "ui/internal/templates/ReportTemplatesNavigator.html"),
		
		constructor: function() {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");
		},
		
		postCreate: function() {
			// Hook the events for the drop-down indicator
			this.connect(this._navIcon, "onmouseover", this._imgMouseOverHandler);
			this.connect(this._navIcon, "onmouseout", this._imgMouseOutHandler);
			this.connect(this._navIcon, "onclick", this._imgClickHandler);
			this.connect(this._togglerLink, "onmouseover", this._togglerLinkMouseOverHandler);
			this.connect(this._togglerLink, "onmouseout", this._togglerLinkMouseOutHandler);
			
			// Fetch the report descriptors (templates)
			var srh = new ServiceResponseHandler(this, "_init", "_remoteError");
			ReportsClient.getReportDescriptors(srh, {});
		},

		_init: function(reportDescriptors) {
			for (var i in reportDescriptors) {
				var rd = reportDescriptors[i];
			}
		},
		
		_imgMouseOverHandler: function(e) {
			e.preventDefault();
			this._dropDownImage.src = DROPDOWN_HOVER;
		},
		
		_imgMouseOutHandler: function(e) {
			e.preventDefault();
			this._dropDownImage.src = DROPDOWN;
		},
		
		_imgClickHandler: function(e) {
			e.preventDefault();
			this._openMenu(e);
			dojo.stopEvent(e);
		},
		
		_togglerLinkMouseOverHandler: function(e) {
			e.preventDefault();
			if (this._menu != null) {
				// We're already in the menu, ignore this
				this._mouseOutOccurred = false;
				return;
			}
			this._dropDown.style.visibility = "visible";
		},
		
		_togglerLinkMouseOutHandler: function(e) {
			e.preventDefault();
			if (this._menu != null) {
				// We're in the menu, don't remove the hover
				// but remember that we left
				this._mouseOutOccurred = true;
				return;
			}
			this._dropDown.style.visibility = "hidden";
		},
		
		_remoteError: function(error) {
			alert(error.message);
		}
		
	});

})();