/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2008. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.reports.web.ui.internal.WorkItemsNavigator");

dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.workitem.web.client.util");
dojo.require("com.ibm.team.process.web.client.projectarea");

(function() { // module container

var session					= com.ibm.team.repository.web.client.session;
var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var ServiceResponseHandler 	= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var TeamServerClient        = com.ibm.team.repository.web.transport.TeamServerClient;
var WorkItemUtil            = com.ibm.team.workitem.web.client.util;

com.ibm.team.reports.web.ui.internal.WorkItemsNavigator = {

	viewWorkItems: function(args) {
		var projectAreaUUID = args.projectAreaUUID;
		if (!projectAreaUUID) {
			var currentProjectArea = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea();
			projectAreaUUID = currentProjectArea.itemId;
		}
		var newArgs = {
		    projectAreaUUID : projectAreaUUID,
			parameterName   : args.parameterName,
			parameterValue  : args.parameterValue
		};
		var serviceRequest = new ServiceRequest(
					"com.ibm.team.reports.workitem.service.internal.IReportWorkItemRestService",
					"getQueryDTO",
					newArgs);
		var responseHandler = new ServiceResponseHandler(
				this,
				"_handleQueryDTO",
				"_remoteError");
		TeamServerClient.invokeService(
				serviceRequest,
				responseHandler);
	},
	
	_handleQueryDTO : function(query) {
		var uri = WorkItemUtil.getQueryURI(query);
		window.location.replace(uri);
	},
	
	_remoteError: function(error) {
		alert(error.message);
	}
};

})();