﻿/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
 
class ColourUtility {

	public static var COLOUR_BLUE:Number = 0xC3CCE0; 			// Blue 		  195, 204, 224
	public static var COLOUR_YELLOW:Number = 0xEADB99;			// Yellow  		  234, 219, 153
	public static var COLOUR_GREEN:Number = 0xAECBAD;			// Green		  174, 203, 173
	public static var COLOUR_PURPLE:Number = 0xC399CE;			// Purple		  195, 153, 206
	public static var COLOUR_ORANGE:Number = 0xE4C396;			// Orange		  228, 195, 150
	public static var COLOUR_GREY:Number = 0xD0D0D0;			// Grey			  208, 208, 208
	public static var COLOUR_LIGHT_BLUE:Number = 0xD8E3E6;		// LightBlue	  216, 227, 230
	public static var COLOUR_LIGHT_YELLOW:Number = 0xF8F8E3;	// LightYellow	  248, 248, 227
	public static var COLOUR_LIGHT_GREEN:Number = 0xE3EED8;		// LightGreen	  227, 238, 216
	public static var COLOUR_LIGHT_PURPLE:Number = 0xD4BECE;	// LightPurple	  212, 190, 206
	public static var COLOUR_LIGHT_ORANGE:Number = 0xE3CFB1;	// LightOrange	  227, 207, 177
	public static var COLOUR_LIGHT_GREY:Number = 0xF6F6F6;		// LightGrey	  246, 246, 246
	public static var COLOUR_DARK_BLUE:Number = 0xBBBFD8;		// DarkBlue		  187, 191, 216
	public static var COLOUR_DARK_YELLOW:Number = 0xD0CC9F;		// DarkYellow	  208, 204, 159
	public static var COLOUR_DARK_GREEN:Number = 0xB7D3A2;		// DarkGreen	  183, 211, 162
	public static var COLOUR_DARK_PURPLE:Number = 0xBA8FB6;		// DarkPurple	  186, 143, 182
	public static var COLOUR_DARK_ORANGE:Number = 0xD2B18E;		// DarkOrange	  210, 177, 142
	public static var COLOUR_DARK_GREY:Number = 0xBEBBBA;		// DarkGrey		  190, 187, 186
	
	public static var RANDOM_COLOURS:Array = [
		ColourUtility.COLOUR_BLUE, 
		ColourUtility.COLOUR_YELLOW,
		ColourUtility.COLOUR_GREEN,
		ColourUtility.COLOUR_PURPLE,
		ColourUtility.COLOUR_ORANGE,
		ColourUtility.COLOUR_GREY,
		ColourUtility.COLOUR_LIGHT_BLUE,
		ColourUtility.COLOUR_LIGHT_YELLOW,
		ColourUtility.COLOUR_LIGHT_GREEN,
		ColourUtility.COLOUR_LIGHT_PURPLE,
		ColourUtility.COLOUR_LIGHT_ORANGE,
		ColourUtility.COLOUR_LIGHT_GREY,
		ColourUtility.COLOUR_DARK_BLUE,
		ColourUtility.COLOUR_DARK_YELLOW,
		ColourUtility.COLOUR_DARK_GREEN,
		ColourUtility.COLOUR_DARK_PURPLE,
		ColourUtility.COLOUR_DARK_ORANGE,
		ColourUtility.COLOUR_DARK_GREY	
	];
	
	public static function darkenColour(hexValue:Number, percentage:Number):Number {
		
		var darkerHexValue:Number;
		
		// Convert Hex to RGB
		var RGBColour = ColourUtility.convertHexToRGB(hexValue);

		var darkerRGBColour:Object = new Object();
		
		for (var propertyName:String in RGBColour) { 
			var colour:Number = RGBColour[propertyName];
			var darkerDecimalValue:Number = colour - Math.round((colour / 100) * percentage);
			
			darkerRGBColour[propertyName] = darkerDecimalValue;
		} 
		
		// Convert RGB to Hex
		darkerHexValue = ColourUtility.convertRGBToHex(darkerRGBColour);
		
		return darkerHexValue;
	}
	
	public static function convertRGBToHex (RGBColour:Object):Number {
		var hex = RGBColour.red << 16 ^ RGBColour.green << 8 ^ RGBColour.blue;
		return hex;
	}
	
	public static function convertHexToRGB(hexValue:Number):Object {
		
		var result:Object = new Object();

		// Example
		//
		// DEC 16760767
		// RGB R255 G191 B191
		// HEX 0xFF BF BF
		// BIN 11111111 10111111 10111111
		
		// Shift 16 bit places right (eliminate 8 green and 8 blue bits)
		// 8 red bits remaining
		result.red = hexValue >> 16;
		// Eliminate 8 red bits (make 0)
		// Shift 8 bit places right (eliminate 8 blue bits)
		// 8 green bits remaining
		result.green = (hexValue ^ (result.red << 16)) >> 8;
		// Eliminate 8 red bits (make 0)
		// Eliminate 8 green bits (make 0)
		// 8 green bits remaining
		result.blue =  (hexValue ^ (result.red << 16) ^ (result.green << 8));
		
		return result;
	}
	
	public static function generateRandomColourPalette(size:Number):Array {
	    var index:Number = 0;
	    var randomColours:Array = new Array();
		
		for (var count:Number = 0; count < size; count++) {
			if (index == ColourUtility.RANDOM_COLOURS.length) {
				index = 0;
			}
			randomColours[count] = ColourUtility.RANDOM_COLOURS[index];
			index++;
		}
		
		return randomColours;
	}
	
}