﻿/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
 
class HorizontalBarXAxis extends XAxis {

	public function HorizontalBarXAxis() {
		super();
	}		
	
	public function draw(parentMC:MovieClip, gridData:GridData):Void {

		super.draw(parentMC, gridData);
		
		var xPosition:Number = this.gridData.xZeroPosition;
		var textFieldWidth:Number = this.gridData.xAxisMaxLabelWidth + (Constants.TEXT_FIELD_MARGIN * 2);
		var yLabelPosition:Number = this.gridData.yZeroPosition + Axis.TICK_LENGTH;
		var xlabel:Number = 0;
		
		for (var step:Number = 0; step < this.gridData.xAxisSectionCount + 1; step++) {

			// Tick
			this.mc.moveTo(xPosition, 
						   this.gridData.yZeroPosition);
			this.mc.lineTo(xPosition, 
						   this.gridData.yZeroPosition + Axis.TICK_LENGTH);		

			// Dashed line
			if (step > 0) {
				this.drawVDashedLine(
					xPosition, 
					this.gridData.yZeroPosition, 
					this.gridData.startY);
			}
			
			// Label
			var xLabelPosition:Number = xPosition -
										(XAxis.LABEL_FORMAT.getTextExtent(String(xlabel)).textFieldWidth / 2);
			var labelID:String = XAxis.X_AXIS_LABEL_NAME + step;
			
			this.mc.createTextField(labelID, 
									this.mc.getNextHighestDepth(), 
									xLabelPosition, 
									yLabelPosition, 
									textFieldWidth, 
									Axis.TEXT_FIELD_HEIGHT);
			this.mc[labelID].text = xlabel;
			this.mc[labelID].setTextFormat(XAxis.LABEL_FORMAT);
			
			xlabel = xlabel + this.gridData.xAxisIncrement;		
			xPosition = xPosition + this.gridData.xAxisSpacing;
		}				
		
		
	}	
	
	public function destroy():Void {
		super.destroy();
	}		
	
}
