/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.module.WorkItemPickerWidget");

// declare dependencies on other Dojo modules
dojo.require("com.ibm.team.workitem.web.ui.internal.module.AbstractChooserWidget");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.SelectWorkItemContent");

(function() {

var ITEM_MESSAGE_SELECT= "oslc_cm.select";

var OSCL_ATTRIB_TYPE= "dc:type";
    
var SelectWorkItemContent = com.ibm.team.workitem.web.ui.internal.view.editor.SelectWorkItemContent;

// declare and implement the widget "class"
dojo.declare("com.ibm.team.workitem.web.ui.internal.module.WorkItemPickerWidget", [ com.ibm.team.workitem.web.ui.internal.module.AbstractChooserWidget ], {

postCreate: function() {
	var body= dojo.body();
    dojo.style(body, "overflow", "hidden"); // no scroll bars
    
    this.inherited(arguments); // Call superclass method...  
},

_openDialog: function(projectArea) {    
    var contentParams = {
        onOk: dojo.hitch(this, this._onOk),
        onCancel: dojo.hitch(this, this._onCancel),
        key: this._dialogArguments,
        projectAreaItemId : projectArea.itemId,
        currentTypeSelection: this._dialogArguments[OSCL_ATTRIB_TYPE]
    };
    var content = new SelectWorkItemContent(contentParams);
    content.setExclusionList(this._dialogArguments.exclusionList || []);
    content.setAllowsMultiple(this._dialogArguments.allowsMultiple || false);
    
    this._setContentWidget(content.domNode);
},

_onOk: function(newItems, key) {
    this._close(newItems, ITEM_MESSAGE_SELECT);
},

_onCancel: function() {
    this._close(null, null);
}
	
});

})();
