/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.editor.parts.WorkItemListPart");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.parts.AnchorAttributePart");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.SelectWorkItemDialog");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.parts.SubscribersPart");
dojo.require("com.ibm.team.workitem.web.client.util");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.LayoutUtil");
/*
 * Handle presentation operations pertaining to the owner attribute
 */
(function() {

var EditorUtil 	= com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil;
var WorkItemUtil 		= com.ibm.team.workitem.web.client.util;

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.editor.parts.WorkItemListPart",
	[com.ibm.team.workitem.web.ui.internal.view.editor.parts.SubscribersPart],
	{
		postCreate: function() {
//			this._chooseAnchor.style.display= "none";
//			var text = this.attributeValue ? this.attributeValue.label : "Unknown";
//			var href = WorkItemUtil.getViewWorkItemUri(this.attributeValue.attributes.itemId);
//			var href; //TODO
//			this.setValueLabel(text, href);
			this.inherited(arguments);
		},
		_getItemLabel: function(item) {
			// item can either be a WorkItemDTO or a WorkItemSummaryDTO
			if (item.typeName) { // WorkItemSummaryDTO
				var name = dojo.string.substitute(this.messages.labelListWorkItem, [ item.typeName, item.id])
					var name = item.typeName + " " + item.id;
			}
			else {
				var properties = com.ibm.team.workitem.web.ui.internal.view.layout.LayoutUtil.getPropertyMap(item, {}, "attributes");
				if (properties.workItemType) {
					var name = dojo.string.substitute(this.messages.labelListWorkItem, [ properties.workItemType.label, properties.id.label])
				}
			}
			return name || this.messages.labelUnknown;
		},
		_getItemHref: function(item) {
			var href;
			if(item.id) {
				href = WorkItemUtil.getViewWorkItemUri(item.id);
			} else {
				var properties = com.ibm.team.workitem.web.ui.internal.view.layout.LayoutUtil.getPropertyMap(item, {}, "attributes");
				if(properties && properties.id && properties.id.id) {
					href = WorkItemUtil.getViewWorkItemUri(properties.id.id);
				}
			}
			return href;
		},
		_openChooseDialog: function(e) {
			this._openWorkItemDialog();
		},
		_openWorkItemDialog: function() {
			if(!EditorUtil.checkLogin()) return;
			var self= this;
			var params= {
				allowsMultiple: true,
				parentController: this.parentWidget.parentController  || this.parentWidget,
				parentElement: this.domNode,
//				exclusionList: [ this.workingCopy.object.itemId ], TODO
				exclusionList: [ ],
				onOk: function(selectedWorkItems, action) {
					self.onWorkItemOk(selectedWorkItems);
				},
				onClose: function() {
					if(self.parentController && self.parentController.focus) {
						self.parentController.focus();	
					}
				}
			};
			new com.ibm.team.workitem.web.ui.internal.view.editor.SelectWorkItemDialog(params);
		},
		onWorkItemOk: function(workItemArray) {
			if(!workItemArray || workItemArray.length ==0) return;
			for(var i=0;i<workItemArray.length;i++) {
				var item = workItemArray[i];
				item.itemId = item.itemId || item.workItemItemId;
			}
			this.workingCopy.addItems({
				items: workItemArray ,
				attributeId: this.attributeId,
				excludeCreator: false
			});
			this.refresh();
		}
	}
);

})();
