/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.actions.RefreshPlanAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.client.internal.ProgressMonitoredServiceResponseHandler"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.client.internal.PlanningClient"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.dialogs.InputDialog"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.TabAttachedPage"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.common.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.Action"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require("dojo.i18n"); //$NON-NLS-1$

(function() {

var ResponseHandler= com.ibm.team.apt.web.client.internal.ProgressMonitoredServiceResponseHandler;	
var PlanningClient= com.ibm.team.apt.web.client.internal.PlanningClient;	

var InputDialog= com.ibm.team.apt.web.ui.internal.view.plan.dialogs.InputDialog;
var TabAttachedPage= com.ibm.team.apt.web.ui.internal.view.plan.TabAttachedPage;

var Assert= com.ibm.team.apt.web.ui.internal.common.Assert;

var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.actions.RefreshPlanAction", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.view.plan.actions.Action], {

	_callCtrl: null,
	_planPage: null,
		
	constructor: function(callCtrl, planPage) {
		this._callCtrl= callCtrl;
		this._planPage= planPage;
	},
	
	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	getId: function() {
		return "plan.refresh"; //$NON-NLS-1$
	},
	
	getName: function() {
		return MSGS.ACTION_REFRESH_PLAN;
	},
	
	getIconUrl: function() {
		return dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/images/refresh.gif"); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	canHandle: function() {
		return !this._planPage.isEditMode();
	},
	
	handle: function(e) {
		var args= dojo.mixin(this._planPage.getViewOptions(), {id: this._planPage.getPlanId()});
		this._callCtrl.refreshPlan(args);
	},

	__sentinel: null // terminates this class definition
});

})();
