/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.PlanItemViewerItemDurationColumn"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.PlanItemViewerItemColumn"); //$NON-NLS-1$
dojo.require("dijit.Menu"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.client.internal.ImageClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.client.internal.WorkItemSaveManager"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.dialogs.SaveErrorDialog"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.dialogs.DurationSelectionDialog"); //$NON-NLS-1$

dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {

var ImageClient				= com.ibm.team.apt.web.client.internal.ImageClient;
var WorkItemSaveManager		= com.ibm.team.apt.web.client.internal.WorkItemSaveManager;
var SaveErrorDialog			= com.ibm.team.apt.web.ui.internal.view.plan.dialogs.SaveErrorDialog;
var DurationSelectionDialog	= com.ibm.team.apt.web.ui.internal.view.plan.dialogs.DurationSelectionDialog;

var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var bind= dojo.string.substitute;

var DurationIconUrl= dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/images/duration_obj.gif"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.PlanItemViewerItemDurationColumn", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.view.plan.planneditems.PlanItemViewerItemColumn], {

	// ---- constructor mixed-in properties --------------------------------------------------------------------------------

	constructor: function(attributeId, planItemViewerItem) {
	},

	// ---- implementation -------------------------------------------------------------------------------------------------
	
	_getLabel: function() {
		return (this._value !== undefined && this._value !== null) ? this._value.getLabel() : null;
	},

	_getIcon: function() {
		return DurationIconUrl;
	},
	
	_isEditable: function() {
		return true;
	},
	
	_getValues: function() {
		return [new com.ibm.team.apt.client.Duration(1000 * 60 * 30), 
		        new com.ibm.team.apt.client.Duration(1000 * 60 * 60),
		        new com.ibm.team.apt.client.Duration(1000 * 60 * 60 * 2),
		        new com.ibm.team.apt.client.Duration(1000 * 60 * 60 * 4),
		        new com.ibm.team.apt.client.Duration(1000 * 60 * 60 * 8),
		        new com.ibm.team.apt.client.Duration(1000 * 60 * 60 * 8 * 2),
		        new com.ibm.team.apt.client.Duration(1000 * 60 * 60 * 8 * 3),
		        new com.ibm.team.apt.client.Duration(1000 * 60 * 60 * 8 * 5),
		        new com.ibm.team.apt.client.Duration(-1)
		];
	},
	
	_setValue: function(newValue) {
		WorkItemSaveManager.compoundSave(function() {
			this._planItem.setAttributeValue(this._attribute, newValue);
		}, this._planItemViewerItem.getViewModel(), {
			showErrorMessage: function(message, description) {
				if (message != null) {
					new SaveErrorDialog({message: message, description: description});
				}
			}
		}, this);
	},
	
	_createMenuEntries: function() {
		var result= new Array();
		
		var values=this._getValues();
		for ( var i = 0; i < values.length; i++) {
			var value= values[i];
			result.push(this._createMenuEntry(
					value.getLabel(), 
					this._getIcon(),
					{newValue: value},
					dojo.hitch(this, function(context) {
						this._setValue(context.newValue);
					})
			));
		}
		
		result.push(this._createMenuEntry(
				MSGS.ACTION_MORE, 
				null,
				{},
				dojo.hitch(this, function() {
					this._openMoreDialog();
				})
		));
		
		return result;
	},
	
	_openMoreDialog: function() {		
		var dialog= new DurationSelectionDialog({
			value: this._value, 
			_self: this,
			onOk: function(value) {this._self._setValue(value);}
		});
	},
	
	__sentinel: null // terminates this class definition
});

})();
