/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.PlanItemViewerItemStateColumn"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.PlanItemViewerItemColumn"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.client.internal.WorkItemSaveManager"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.dialogs.SaveErrorDialog"); //$NON-NLS-1$

(function() {

var WorkItemSaveManager		= com.ibm.team.apt.web.client.internal.WorkItemSaveManager;
var SaveErrorDialog			= com.ibm.team.apt.web.ui.internal.view.plan.dialogs.SaveErrorDialog;

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.PlanItemViewerItemStateColumn", [com.ibm.team.apt.web.ui.internal.view.plan.planneditems.PlanItemViewerItemColumn], {//$NON-NLS-1$

	// ---- constructor mixed-in properties --------------------------------------------------------------------------------
	
	constructor: function(attributeId, planItemViewerItem) {
		
	},

	// ---- implementation -------------------------------------------------------------------------------------------------
	
	_isEditable: function() {
		if (this._attribute.attributeType == com.ibm.team.apt.client.PlanningAttributeType.WORKFLOW_STATE)
			return !this._attribute.readOnly && this._planItem.getWorkflowInfo().getActions(this._planItem).length > 0;
			
		return false;
	},
	
	_getValues: function() {
		var workflowInfo= this._planItem.getWorkflowInfo();
		var actions= workflowInfo.getActions(this._planItem);
		// DON'T: We piggyback the label/iconUrl
		for (var i= 0; i < actions.length; i++) {
			actions[i].label= actions[i].label || workflowInfo.getStateLabel(actions[i].endState);
			actions[i].iconURL= actions[i].iconURL || workflowInfo.getStateIcon(actions[i].endState);
		}
		return actions;
	},
	
	_setValue: function(newValue) {
		WorkItemSaveManager.compoundSave(function() {
			this._planItem.setAttributeValue(com.ibm.team.apt.client.PlanItem.WORKFLOW_ACTION, newValue);
		}, this._planItemViewerItem.getViewModel(), {
			showErrorMessage: function(message, description) {
				if (message != null) {
					new SaveErrorDialog({message: message, description: description});
				}
			}
		}, this);
	},
	
	__sentinel: null // terminates this class definition
});

})();
