/*
 * Licensed Materials - Property of IBM
 * Rational ClearQuest 
 * (C) Copyright IBM Corp. 2009  All Rights Reserved
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 */

dojo.provide("com.ibm.rational.cm.web.ui.utils.Bookmark");

dojo.require("dojo.i18n");
dojo.require("com.ibm.rational.cm.web._base.url");
dojo.require("com.ibm.rational.cm.web.ui.page.PropertyManager");
dojo.require("com.ibm.rational.cm.web.ui.view.common.ButtonDialog");

dojo.requireLocalization("com.ibm.rational.cm.web.ui","cqRecordStrings");

(function(){

var messages = dojo.i18n.getLocalization("com.ibm.rational.cm.web.ui", "cqRecordStrings");
var _bookmarkDlg, _emailDlg;

/*
 * Adds to browser bookmark
 * {
 *	type: String RECORD|LIST|CHART|REPORT
 *	resourceId: String (stableLocation),
 * 	title: String (label for link)
 * }
 */
com.ibm.rational.cm.web.ui.utils.addToBookmark = function(obj){
	var self = this;
	var resourceId = obj.stableLocation;
	com.ibm.rational.cm.web.ui.page.propManager.getProperties({
		resourceId: resourceId,
		onLoad: function(props){
			// get title
			var type = obj.type;
			var title = obj.title;
			if(!title){
				title = "";
				if(type == "RECORD" && props.recordType){
					title += props.recordType + "/";
				}
				title += props.displayName;
			}
			
			var url = com.ibm.rational.cm.web.getActionHref(type, resourceId, title);
			var bookmarkTitle = messages.falcon+ title;
			if(dojo.isIE){ // IE
				url = location.href;
				window.external.AddFavorite(url, bookmarkTitle);
			}else{
				if(!_bookmarkDlg){
					dojo["require"]("com.ibm.rational.cm.web.ui.utils.BookmarkContent");
					var content = new com.ibm.rational.cm.web.ui.utils.BookmarkContent();
//					dojo["require"]("com.ibm.rational.cm.web.ui.view.common.ButtonDialog");
					_bookmarkDlg = new com.ibm.rational.cm.web.ui.view.common.ButtonDialog({
						title: messages.bookmarks,
						hasOkBtn: false
					});
					_bookmarkDlg.setContent(content);
					_bookmarkDlg.resize({ w:500, h:300 });
					_bookmarkDlg.startup();
				}
				_bookmarkDlg.getContent().setLink(url, bookmarkTitle);
				_bookmarkDlg.show();
			}
		}
	});
}

com.ibm.rational.cm.web.ui.utils.addEmailLink = function(obj){
	var self = this;
	var resourceId = obj.stableLocation;
	com.ibm.rational.cm.web.ui.page.propManager.getProperties({
		resourceId: resourceId,
		onLoad: function(props){
			// get title
			var type = obj.type;
			var title = obj.title;
			if(!title){
				title = "";
				if(type == "RECORD" && props.recordType){
					title += props.recordType + "/";
				}
				title += props.displayName;
			}
			
			var url = com.ibm.rational.cm.web.getActionHref(type, resourceId, title);
			var bookmarkTitle = messages.falcon+ title;
			if(!_emailDlg){
				dojo["require"]("com.ibm.rational.cm.web.ui.utils.EmailContent");
				var content = new com.ibm.rational.cm.web.ui.utils.EmailContent();
//				dojo["require"]("com.ibm.rational.cm.web.ui.view.common.ButtonDialog");
				_emailDlg = new com.ibm.rational.cm.web.ui.view.common.ButtonDialog({
					title: messages.email_title,
					hasOkBtn: false
				});
				_emailDlg.setContent(content);
				_emailDlg.resize({ w:500, h:300 });
				_emailDlg.startup();
			}
			_emailDlg.getContent().setLink(url, bookmarkTitle);
			_emailDlg.show();
		}
	});
}

})();