/*
 * Licensed Materials - Property of IBM
 * Rational ClearQuest 
 * (C) Copyright IBM Corp. 2007, 2009  All Rights Reserved
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 */

dojo.provide("com.ibm.rational.cm.web.ui.utils.EmailContent");

dojo.require("dojo.i18n");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.requireLocalization("com.ibm.rational.cm.web.ui", "cqRecordStrings");

dojo.declare(
	"com.ibm.rational.cm.web.ui.utils.EmailContent",
	[ dijit._Widget, dijit._Templated ],
{
	templatePath: dojo.moduleUrl("com.ibm.rational.cm.web", "ui/utils/templates/EmailContent.html"),	
	
	postMixInProperties: function(){
		this.messages = dojo.i18n.getLocalization("com.ibm.rational.cm.web.ui", "cqRecordStrings", this.lang);
		this.inherited(arguments);
	},
	
	setLink: function(url, title){
		var baseUrl = location.protocol + "//" + location.host + location.pathname;
		this.mailToLink.href = "mailto:?subject=" + encodeURIComponent(title) + "&body=" + encodeURIComponent(baseUrl + url) + "%0d%0a";		
		this.emailLink.href = url;
		this.emailLink.innerHTML = com.ibm.rational.cm.web.sanitizeString(title);
	}
});