/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui2.internal.widget.AbstractWidget");

dojo.require("dojox.data.dom");
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemClient");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil");
(function() {
var ServiceResponseHandler	= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var WorkItemClient			= com.ibm.team.workitem.web.client.internal.WorkItemClient;
var EditorUtil 	= com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil;
var ActionRegistry = null; // bind to ActionRegistry later
//var LayoutTester = com.ibm.team.workitem.web.module.ui.LayoutTester;
//var ProgressTester = com.ibm.team.workitem.web.module.ui.ProgressTester;


var ACTION_PREFIX = "com.ibm.team.workitem.web.widget.";
dojo.declare("com.ibm.team.workitem.web.ui2.internal.widget.AbstractWidget", null, {
		addChildWidget: function(aDestroyable) {
			this._childWidgets = this._childWidgets || [];
			this._childWidgets.push(aDestroyable);
		},
		_destroyChildren: function() {
		    if(!this._childWidgets || this._childWidgets.length==0) return;
			for (var i = 0; i < this._childWidgets.length; i++) {
      			if (this._childWidgets[i] && this._childWidgets[i].destroy) {
						this._childWidgets[i].destroy();
						this._childWidgest[i] = null;
					}
            }
            this._childWidgets = [];
		},
	 _modifyCategoryValues: function(parms) {
		var currentValue = parms.value;
		var possibleValues = parms.possibleValues
		if(!currentValue) return;
		if(!possibleValues) return;
		
		var found = false;
		// Map the categories to fully qualified names and search for current value
		var categories = parms.categories
		for(var i=0;i<categories.length;i++) {
				var fullLabel = EditorUtil._getFullName(categories, i, "label", "unmodifiedLabel");
				categories[i].title = fullLabel;
				categories[i].shortLabel = categories[i].label;					

				if(!dojo.isIE && !dojo.isMozilla) {
				    if(fullLabel) {
						var count = fullLabel.match(/\//g);
						count = count==null ? 0 : count.length;
						var prefix = "";
						for(var j=0;j<count;j++) {
							prefix += ".";
						}
						if(count >0 ) prefix += " ";
						categories[i].unmodifiedLabel = categories[i].label;
						categories[i].label = (prefix + (categories[i].label.replace(/  /g, "").replace(/  /g, ""))).replace(/  /g, " ");
						categories[i].shortLabel = categories[i].label;
				    }
				}

				
				if (categories[i].id == currentValue.id) {
					found = true;
					if (!dojo.isIE) {
						categories[i].label = this._getClippedCategoryLabel(categories[i].title.replace(/ \/ /g, "/"));
					}
				}

				categories[i].title = fullLabel;
			}
		
		// If the current category is not in the allCategories list, then add it
		if(!found) {
			var argumentArray = [currentValue.label];
			if(currentValue.arguments) {
				argumentArray = currentValue.arguments.split("/");
			}
			if(argumentArray.length == 1) {
				currentValue.title = currentValue.label;
			} else { // currentValue.arguments cannot be null
				currentValue.title = currentValue.arguments.replace(/\//, " / ");
				currentValue.label = this._getClippedCategoryLabel(currentValue.arguments);
			}
			currentValue.shortLabel = currentValue.label;
			categories.unshift(currentValue);
		}
		
		if (this.workingCopy.isNew()) {
			categories = this._filterCategories(parms.categories) 
			}
		return { possibleValues: categories };
	},
	_getOriginalTarget: function(e) {
		return EditorUtil._getOriginalTarget(e);
	},
	_getCurrentSelectValue: function(select) {
		if(select.selectedIndex == -1 || !select.options || select.options.length ==  0) return null;
		var currentOption= select.options[select.selectedIndex];
		if(!currentOption) return null;
		if(this.possibleValues) {
			return this.possibleValues[select.selectedIndex];
		}
		return select.value;
	},
	/*
	 * Filter out all but top-level categories and add an extra "(Show All)"
	 * option which on selection will display all of the categories.
	 */
	_filterCategories: function(categoryArr) {
		var newArr= [];
		newArr.push({label: this.messages.optionShowAll, id: "showall"});
		for (var i=0; i<categoryArr.length; i++) {
			if (EditorUtil._getIndent(categoryArr[i].label) === 0) {
				newArr.push(categoryArr[i]);
			}
		}
		return newArr;
	}
});


})();
