/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.client.internal.attributes.SequenceValueAttribute"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.client.SequenceValue"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.internal.attributes.PlanItemWorkItemAttribute"); //$NON-NLS-1$

(function() {
	
var SequenceValue					= com.ibm.team.apt.client.SequenceValue;
var PlanItemWorkItemAttribute		= com.ibm.team.apt.client.internal.attributes.PlanItemWorkItemAttribute;

dojo.declare("com.ibm.team.apt.client.internal.attributes.SequenceValueAttribute", PlanItemWorkItemAttribute, { //$NON-NLS-1$

	constructor: function(descriptor, workItemAttribute, valueIndex) {
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	_convertToPlanItem: function(value, receiver) {
		if (receiver.__cachedSequenceValue == null) {
			var rawValue= this.inherited(arguments);
			receiver.__cachedSequenceValue= SequenceValue.FACTORY.valueOf(rawValue, receiver.getOwner().itemId);
		}
		return receiver.__cachedSequenceValue;
	},

	_convertToWorkItem: function(value, receiver) {
		receiver.__cachedSequenceValue= value;
		var serializedValue= value.serializeSequenceValue(receiver.getOwner().itemId);
		return this.inherited("_convertToWorkItem", arguments, [ serializedValue, receiver ]); //$NON-NLS-1$
	},

	__sentinel: null // terminates this class definition
});

})();
