/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.client.internal.schedule.TimespanIterator"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.client.internal.Timespan"); //$NON-NLS-1$

(function() {

var Timespan						= com.ibm.team.apt.client.internal.Timespan;

dojo.declare("com.ibm.team.apt.client.internal.schedule.TimespanIterator", null, { //$NON-NLS-1$
	
	__current: null,
	__currentIndex: -1,
	__forward: true,
	
	constructor: function(timespans) {
		this.__timespans= timespans;
		this.__timespans.sort( function(a, b) {
			return a.compareTo(b);
		});
	},

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	reset: function(earliestStart, forward) {
		var current= null;
		var currentIndex= forward ? 0 : this.__timespans.length - 1;

		while (forward ? currentIndex < this.__timespans.length : currentIndex >= 0) {
			current= this.__timespans[currentIndex];
			if (forward) {
				if (current.start.afterEq(earliestStart) || current.end.after(earliestStart))
					break;
				currentIndex++;
			} else {
				if (current.end.beforeEq(earliestStart) || current.start.before(earliestStart))
					break;
				currentIndex--;
			}
		}

		if (forward && currentIndex < this.__timespans.length) {
			if (earliestStart.after(current.start)) {
				this.__current= new Timespan(earliestStart, current.end);
			} else {
				this.__current= current;
			}
		} else if (!forward && currentIndex >= 0) {
			if (earliestStart.before(current.end)) {
				this.__current= new Timespan(current.start, earliestStart);
			} else {
				this.__current= current;
			}
		} else {
			this.__current= null;
		}
		this.__currentIndex= currentIndex;
		this.__forward= forward;
	},
	
	current: function() {
		return this.__current;
	},

	next: function() {
		if (this.__current != null) {
			if (this.__forward && this.__currentIndex < this.__timespans.length - 1) {
				this.__current= this.__timespans[++this.__currentIndex];
			} else if (!this.__forward && this.__currentIndex > 0) {
				this.__current= this.__timespans[--this.__currentIndex];
			} else {
				this.__current= null;
			}
		}
		return this.__current;
	},

	__sentinel: null // terminates this class definition
});

})();
